<template>
  <section class="p-4 my-4">
    <div class="d-flex justify-content-between">
      <div class="col-6">
        <h1>Servizi <span v-if="tag" class="badge badge-secondary">{{ tag }}</span></h1>
      </div>
      <div class="col-6">
        <div class="form-group" v-if="serviceName">
          <input v-model="serviceName" type="search" class="autocomplete" placeholder="Nome del servizio da cercare"
                 id="ricerca">
          <span class="autocomplete-icon" aria-hidden="true">
                <svg class="icon icon-sm"><use xlink:href="bootstrap-italia/dist/svg/sprites.svg#it-search"></use></svg>
            </span>
          <label for="ricerca" class="sr-only">Cerca servizio</label>
        </div>
      </div>
    </div>
    <div class="my-5" v-if="services && services.length > 0">
      <div class="row" id="services_list">
        <div v-for="service in services" :key="service.id"
             class="col-12 col-sm-6 col-lg-4">
          <article class="card-wrapper">
            <div class="card">
              <div class="card-body">
                <div class="category-top">
                  <a class="category" href="#" disabled>{{ service['tags'][0] }}</a>
                  <span class="data">{{ $filters.date(service['created']) }}</span>
                </div>
                <h5 class="card-title big-heading">{{ service['title'] }}</h5>
                <p class="card-text text-truncate">{{ service['description'] }}</p>
                <p class="card-text text-truncate">Ultima modifica
                  {{ $filters.momentAgo(service['modified']) }}</p>
                <div v-if="service['deprecated']" class="chip chip-danger">
                  <span class="chip-label">Deprecato</span>
                </div>
                <router-link :to="{path:'/services/' + service['_id']}" class="read-more">
                  <span class="text">Accedi al servizio</span>
                  <svg class="icon">
                    <use xlink:href="bootstrap-italia/dist/svg/sprites.svg#it-arrow-right"></use>
                  </svg>
                </router-link>
              </div>
            </div>
          </article>
        </div>
      </div>
    </div>
    <div v-if="errorMessage" class="alert alert-warning">
      <p>{{ errorMessage }}</p>
    </div>
    <div class="my-5 alert alert-info" v-if="!services && loading">
      Non sono presenti servizi
    </div>
  </section>
  <section v-if="loading" class="p-4 my-4">
    <div class="justify-content-center d-flex my-3">
      <div class="progress-spinner progress-spinner-active">
        <span class="sr-only">Caricamento...</span>
      </div>
    </div>
  </section>
</template>

<script>
import axios from "axios";

export default {
  name: 'Services',
  data() {
    return {
      serviceName: '',
      services: [],
      errorMessage: '',
      loading: false
    };
  },
  methods: {

    getServiceByName(value) {
      this.services = [];
      this.loading = true;
      axios.get(window.location.protocol + "//" + window.location.hostname + `/api/form?name=${value}&limit=100`).then((result) => {
        this.services = result.data;
        this.loading = false
      }, () => {
        this.errorMessage = 'Non è stato possibile recuperare i servizi';
        this.loading = false;
      });
    },
    getServices() {
      let queryString = '';
      this.loading = true;
      switch (this.$route.query.tag) {
        case 'custom':
          queryString = '?exclude_tags=component,basic';
          break;
        case 'basic':
          queryString = '?exclude_tags=component,custom';
          break;
        case 'component':
          queryString = '?exclude_tags=basic,custom';
          break;
        default:
          queryString = '?exclude_tags=';
      }
      axios.get(window.location.protocol + "//" + window.location.hostname + `/api/form${queryString}&limit=100&show_deprecated=true`).then((result) => {
        this.services = result.data;
        this.loading = false
      }, () => {
        this.errorMessage = 'Non è stato possibile recuperare i servizi';
        this.loading = false
      });
    },
  },
  computed: {
    tag() {
      return this.$route.query.tag;
    },
  },
  watch: {
    $route() {
      this.serviceName = '';
      this.getServices();
    },
    serviceName(value) {
      this.getServiceByName(value);
    },
  },
  beforeMount() {
    this.getServices();
  },

};
</script>

<style scoped>

</style>
